## sbt 0.13.13

=== debian/changelog ===
sbt (0.13.13-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Apply patch for reproducible builds (Closes: #861608)
    - Thank you to Chris Lamb for the patch.

 -- tony mancill <tmancill@debian.org>  Fri, 11 Aug 2017 15:25:11 -0700

sbt (0.13.13-1) experimental; urgency=medium

  * Initial release. (Closes: #855304)

 -- Frédéric Bonnard <frediz@linux.vnet.ibm.com>  Fri, 14 Apr 2017 09:37:19 +0000
