=== debian/control ===
Source: sbt
Section: java
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Frédéric Bonnard <frediz@linux.vnet.ibm.com>
Build-Depends: debhelper (>= 10), default-jdk, git, javahelper, maven-repo-helper, scala (>= 2.11)
Standards-Version: 3.9.8
Homepage: http://www.scala-sbt.org

Package: sbt
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, libsbt-java
Recommends: ${java:Recommends}
Description: Scala Build Tool
 Sbt is a build tool for Scala, Java, and more. While it is written in Scala
 and provides many Scala conveniences, it is a general purpose build tool.
 Little or no configuration required for simple projects
 Scala-based build definition that can use the full flexibility of Scala code

Package: libsbt-java
Architecture: all
Depends: ${misc:Depends}, libsbt-test-interface-java, libscala-tools-sbinary-java, libsbt-serialization-java, libsbt-launcher-interface-java, libjsch-java, sbt-ivy, libsbt-template-resolver-java, scala
Description: Scala Build Tool libraries
 Sbt is a build tool for Scala, Java, and more. While it is written in Scala
 and provides many Scala conveniences, it is a general purpose build tool.
 Little or no configuration required for simple projects
 Scala-based build definition that can use the full flexibility of Scala code
 .
 This package contains sbt Java libraries.
