=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/sbt-$1\.tar\.gz/,uversionmangle=s/-(RC|M)/~$1/ \
  https://github.com/sbt/sbt/tags .*/v?(0\.\d\S*)\.tar\.gz
#opts=component=launcher,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/sbt-launcher-package-$1\.tar\.gz/,uversionmangle=s/-(RC|M)/~$1/ \
#  https://github.com/sbt/sbt-launcher-package/tags .*/v?(\d\S*)\.tar\.gz ignore
